#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h"
#include"ppmio.h"
#include"affine.h"
#include"interpolation.h"

//backward mapping
int main(int argc,char *argv[]){
   if(argc!=4){
    printf("Please use as ./Rotation input.ppm output.ppm Angle(double)\n");
    printf("For example, ./Rotation lena.ppm lena_rotate_60.ppm 60.0\n");
    
    return 0;
  }

  /* file I/O */
  Image *inR = new Image();
  Image *inG = new Image();
  Image *inB = new Image();

  getPPM(inR,inG,inB,argv[1]);
  
  
  /* end file I/O */



  /* main processing */
  int i,j;
  
  
  /* Transformation Matrix */
  double A[2][2];
  A[1][1]=A[0][0]=1.0;
  A[0][1]=A[1][0]=0.0;

  
  // Test Rotation
  double Rotation_Angle = atof(argv[3]);
  Rotation(A,Rotation_Angle);
  

  /* Translation Vector */
  double t[2];
  
  t[0]=t[1]=0.0;// no translation
  
  /* Set New Image Size*/
  double new_size[2];
  setNewSize(inR->sx,inR->sy,A,t,new_size);
  double centerIn[2];
  centerIn[0] = ((double)(inR->sx))*0.5;
  centerIn[1] = ((double)(inR->sy))*0.5;

  
  
  
  Image *outR = new Image(((int)(new_size[0])),((int)(new_size[1])));
  Image *outG = new Image(((int)(new_size[0])),((int)(new_size[1])));
  Image *outB = new Image(((int)(new_size[0])),((int)(new_size[1])));
  double centerOut[2];
  centerOut[0] = 0.5*(((double)(outR->sx))-t[0]);
  centerOut[1] = 0.5*(((double)(outR->sy))-t[1]);
  
  printf("Old Size (%d,%d) to New Size: (%d,%d)\n",inR->sx,inR->sy,outR->sx,outR->sy);
  
  
  /* Input Zero Value */
  for(i=0;i<outR->sy;i++)
    for(j=0;j<outR->sx;j++){
      outR->img[i][j] = 0.0;
      outG->img[i][j] = 0.0;
      outB->img[i][j] = 0.0;
    }
  
  
 
  /* Backward Mapping with Interpolations */
  double uv[2],xy[2];
  for(i=0;i<outR->sy;i++){
    xy[1] = ((double)(i));
    for(j=0;j<outR->sx;j++){
      xy[0] = ((double)(j));
      //AffineTransformation_BW(xy,A,t,uv);
      AffineTransformation_BW(xy,A,t,centerIn,centerOut,uv);
      if(uv[0]>=0.0&&uv[1]>=0.0&&uv[0]<inR->sx&&uv[1]<inR->sy){
     
	//Nearest Neighbor
	/* outR->img[i][j] = NearestNeighbor(inR,uv);
	outG->img[i][j] = NearestNeighbor(inG,uv);
	outB->img[i][j] = NearestNeighbor(inB,uv);
	*/
      
      /* Liner Interpolation */
      
	/* outR->img[i][j] = LinearInterpolation(inR,uv);
	 outG->img[i][j] = LinearInterpolation(inG,uv);
	 outB->img[i][j] = LinearInterpolation(inB,uv);
	*/
	/* Cubic Interpolation */
       outR->img[i][j] = CubicInterpolation(inR,uv);
      outG->img[i][j] = CubicInterpolation(inG,uv);
      outB->img[i][j] = CubicInterpolation(inB,uv);
      
      }
      
    }
  }
  
  

  /* end main processing */


   savePPM(outR,outG,outB,argv[2]);

  delete outR;
  delete outG;
  delete outB;
  
  delete inR;
  delete inG;
  delete inB;
  
  return 0;
}
